/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.kintai.workflow.action;

import java.util.Date;

import jp.mosp.common.CommonConst;
import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.utils.DateUtil;
import jp.mosp.common.utils.StringUtil;
import jp.mosp.common.utils.TimeUtil;
import jp.mosp.common.utils.VariousUtil;
import jp.mosp.kintai.common.action.MosPWorkflowAction;
import jp.mosp.kintai.common.part.KintaiApprovalPart;
import jp.mosp.kintai.kintai.dto.MSyukkinboDto;
import jp.mosp.kintai.workflow.dto.CtOvertimeRequestDto;
import jp.mosp.kintai.workflow.vo.DayApprovalCardVo;

/**
 * @author yoshida
 *
 */
public class DayApprovalCardAction extends MosPWorkflowAction {
	
	// コマンド
	/**
	 * 
	 */
	public static final String	CMD_CARD_SELECT		= "K2146";
	private static final String	CMD_CARD_APPROVED	= "K2147";
	private static final String	CMD_CARD_RETURNED	= "K2148";
	

	/**
	 * 
	 */
	public DayApprovalCardAction() {
		super();
	}
	
	public void action() throws Exception {
		// VO準備
		prepareVo(false);
		// 初期処理
		init();
		// コマンド毎の処理
		if (CMD_CARD_SELECT.equals(cmd)) {
			// 表示(キーで情報を検索)
			select();
		} else if (CMD_CARD_APPROVED.equals(cmd)) {
			// 承認
			approved();
		} else if (CMD_CARD_RETURNED.equals(cmd)) {
			// 差戻
			returned();
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}
	
	@Override
	protected BaseVo getSpecificVo() {
		return new DayApprovalCardVo();
	}
	
	@Override
	protected void init() throws Exception {
		DayApprovalCardVo vo = (DayApprovalCardVo)getVo();
		// ユーザー情報取得
		getInfo(user.getUserId());
		// 手当一覧
		vo.setAryAllowance(getMosPCodeArray(CommonConst.TID_ALLOWANCE_NAME));
	}
	
	@Override
	protected void select() throws Exception {
		MSyukkinboDto dto = kintai().getSyukkinboInfo(key1, key2);
		chkExist(dto);
		// 承認状況の設定
		setFields(dto);
	}
	
	/**
	 * 勤怠承認処理
	 * @throws Exception 	例外処理が発生した場合
	 */
	private void approved() throws Exception {
		// DTOの取得
		MSyukkinboDto dto = (MSyukkinboDto)getSessionDto();
		DayApprovalCardVo vo = (DayApprovalCardVo)getVo();
		// 排他確認
		chkExclusive(dto, kintai().getSyukkinboInfo(dto.getKCode(), dto.getHizuke(), true));
		// DTOの再取得
		MSyukkinboDto retDto = dto;
		// 承認処理
		if (runDailyApprovalProcess(dto.getKCode(), DateUtil.convStringDateToDate(dto.getHizuke()), vo.getTxtComment(),
				true)) {
			// コミット
			commit();
			// DTOの再取得
			retDto = kintai().getSyukkinboInfo(dto.getKCode(), dto.getHizuke());
			chkUpdate(retDto);
			// メッセージ設定
			if (KintaiApprovalPart.is1stApproved(retDto)) {
				setMessage(getMessage(CommonConst.MSG_DONE, CommonConst.NAM_1ST_APPROVED));
			}
			if (KintaiApprovalPart.is2ndApproved(retDto)) {
				setMessage(getMessage(CommonConst.MSG_DONE, CommonConst.NAM_2ND_APPROVED));
			}
		}
		// VOに情報をセット
		setFields(retDto);
	}
	
	/**
	 * 勤怠差戻処理
	 * @throws Exception 	例外処理が発生した場合
	 */
	private void returned() throws Exception {
		// DTOの取得
		MSyukkinboDto dto = (MSyukkinboDto)getSessionDto();
		DayApprovalCardVo vo = (DayApprovalCardVo)getVo();
		// パラメータの妥当性確認
		vo.validate();
		// 排他確認
		chkExclusive(dto, kintai().getSyukkinboInfo(dto.getKCode(), dto.getHizuke(), true));
		// DTOの再取得
		MSyukkinboDto retDto = dto;
		// 差戻処理
		if (runDailyApprovalProcess(dto.getKCode(), DateUtil.convStringDateToDate(dto.getHizuke()), vo.getTxtComment(),
				false)) {
			// コミット
			commit();
			// メッセージ設定
			setMessage(getMessage(CommonConst.MSG_APPROVAL_RETURNED, ""));
			// DTOの再取得
			retDto = kintai().getSyukkinboInfo(dto.getKCode(), dto.getHizuke());
			chkUpdate(retDto);
		}
		// VOに情報をセット
		setFields(retDto);
	}
	
	/**
	 * 勤怠情報をVOセット
	 * @param dto		対象DTO
	 * @throws Exception 	例外処理が発生した場合
	 */
	private void setFields(MSyukkinboDto dto) throws Exception {
		DayApprovalCardVo vo = (DayApprovalCardVo)getVo();
		// 名称設定
		kintai().replaceCodeToName(dto);
		// VOに情報をセット
		vo.setFields(dto);
		// モード設定
		setApprovalStatus(dto);
		// 各種申請情報設定
		setRequestInfo(dto);
		// 労使協定情報設定
		setLaborAgreementInfo(dto.getKCode(), DateUtil.convStringDateToDate(dto.getHizuke()));
		// 時間外警告対応
		vo.setCaution(checkCautionOverTimeMonthly(dto.getKCode(), DateUtil.convStringDateToDate(dto.getHizuke())));
		// 月60時間時間外警告対応
		vo.setWarning(checkWarningOverTimeMonthly(dto.getKCode(), DateUtil.convStringDateToDate(dto.getHizuke())));
	}
	
	/**
	 * 承認状況情報の設定
	 * @param dto			対象DTO
	 * @throws Exception  	例外処理が発生した場合
	 */
	private void setApprovalStatus(MSyukkinboDto dto) throws Exception {
		DayApprovalCardVo vo = (DayApprovalCardVo)getVo();
		setLabelBasisInfo(dto.getKCode());
		String statusCode = dto.getSnRiyuu();
		vo.setLblStatus(getApprovalName(statusCode));
		// モード設定
		vo.setMode(DayApprovalCardVo.MODE_VIEW);
		// 承認者確認
		if (part().kintaiApproval().isApprover(dto.getKCode(), userBasis.getKCode(), statusCode,
				DateUtil.convStringDateToDate(dto.getHizuke()))) {
			vo.setMode(DayApprovalCardVo.MODE_SELECT);
			if (KintaiApprovalPart.is1stApproved(statusCode)) {
				vo.setMode(DayApprovalCardVo.MODE_APPROVED);
			}
		}
		// セッションにDTOをセット
		setSessionDto(dto);
	}
	
	/**
	 * 各種申請情報設定
	 * @param dto		対象DTO
	 * @throws Exception 	例外処理が発生した場合
	 */
	private void setRequestInfo(MSyukkinboDto dto) throws Exception {
		DayApprovalCardVo vo = (DayApprovalCardVo)getVo();
		String kCode = dto.getKCode();
		Date targetDate = DateUtil.convStringDateToDate(dto.getHizuke());
		// 休暇申請
		vo.setAryLblHolidayRequest(getLabelHolidayRequestStatusArray(kCode, targetDate));
		// 残業申請
		CtOvertimeRequestDto overtimeDto = getOverTimeRequest(kCode, targetDate);
		if (VariousUtil.isNotNull(overtimeDto)) {
			StringBuffer sb = new StringBuffer();
			String statusCode = toKintaiApprovalStatus(overtimeDto.getWorkflow());
			// 下書き以外
			if (!KintaiApprovalPart.isDraft(statusCode)) {
				// 申請時間
				sb.append(TimeUtil.convIntegerTimeToJPHours(overtimeDto.getOverTime()));
				// 承認状況
				sb.append(StringUtil.surroundBracket(getApprovalName(statusCode)));
				vo.setLblOverTimeRequest(sb.toString());
			}
		}
	}
	
}
